#! /usr/bin/python
#  Reading ProMC file using CPython
#  S.Chekanov (ANL)
import sys,zipfile

if len(sys.argv) != 2:
    print "Usage: python reader [inputfile]"
    sys.exit()

sys.path.append("modules/")
from ProMCHeader_pb2 import *
from ProMC_pb2 import *
from ProMCStat_pb2 import *
from ProMCDescription_pb2 import *

 
z = zipfile.ZipFile(sys.argv[1], "r")
print "Get doc for  zipfile: ",z.__doc__
print "Get table of contents", z.printdir()
print "Get namelist: ",z.namelist()
#print "Get infolist: ",z.infolist()	# a list of object pointers
#print "Get getinfo for version: ",z.getinfo("version")	# object pointer for version
print "File version=",z.read("version")
print "File description=",z.read("promc_description")
print "Nr of events=", z.read("promc_nevents")
#print "0:",z.read("0")		# is binary data

# retrive information from the header file
# ie from ProMCHeader_pb2.py
header=ProMCHeader()
header.ParseFromString(z.read("header"))
print "ID1=",header.id1
print "ID2=",header.id2
print "MomentumUnit=",header.MomentumUnit
print "LengthUnit  =",header.LengthUnit
gev=float(header.MomentumUnit)


# some PDG is stored?
print "Examine PDG data stored in header.particleData"
pdata=header.particleData 
print "Length of data stored in header.particleData is ",len(pdata)
print "Indx Name   mass (GeV)   ID"
for i in range(len(pdata)):
      print i,pdata[i].name,pdata[i].mass,pdata[i].id
      if i>10 : break

 
######### loop over events ####################
tot=0;
ncnt=0;
# loop over events in archive 0..N
for n in z.namelist():
    if n.isdigit(): 
      sumOfPz = 0.0
      ncnt=ncnt+1
      if ( ncnt <= 10 or ncnt % 100 == 0 ) : print "Event=",str(n)  
      event=ProMCEvent()
      event.ParseFromString(z.read(n))
      if (int(n)<3): # debug first 3 events 
        pdg_id=event.particles.pdg_id
        Px=event.particles.Px
        Py=event.particles.Py
        Pz=event.particles.Pz
        print "length of pdg_id is number of stored particles = ", len(pdg_id)
        for j in range(len(pdg_id)):
               if ( j % 100 == 0 or j<10 ) : print j," px=",Px[j]/gev," py=",Py[j]/gev," pz=",Pz[j]/gev
	       sumOfPz = sumOfPz + Pz[j]/gev
	print "Sum of Pz over stored particles is ",sumOfPz
z.close()
print "Found ", ncnt, " events."
#print "Total record size=",tot/1048576, ' MB'
